
module app.home.controllers {
    import IMenuItem = interfaces.IMenuItem;

    class HomeController extends core.controllers.CoreController {
        navigate = (path: string) => {
            this.$location.path(path);
        }
        menus: IMenuItem[];

        constructor(
            private $location: ng.ILocationService,
            $route: ng.route.IRouteService,
            $timeout: ng.ITimeoutService,
            private menuService: home.services.IMenuService) {
            super();
            var self = this;
            var isLoaded: boolean = $route.routes["/home"];
            menuService.getMenu()
                .success((data) => {
                    self.menus = [];
                    angular.forEach(data, (menu: IMenuItem) => {
                        if (menu.IsMenu) {
                            self.menus.push(menu);
                        }

                    });
                    var stop = $timeout(() => {
                        if ($route.routes["/home"] && !isLoaded) {
                            $timeout.cancel(stop);
                            isLoaded = true;
                            $route.reload();
                        }
                    }, 50);
                })

                .error((result: any, status: number, headers: (headerName: string) => string, config: ng.IRequestConfig) => {
                    if (status !== 0) {
                        alert("error");
                    }

                });
        }
    }

    angular.module("app.home.controllers", ["app.home.services"])
        .controller("homeController", ["$location", "$route", "$timeout", "app.home.menuService", HomeController]);
}