
module app.reports.reportsController {

    import IUtilities = core.services.IUtilities;
    import IReport = reports.models.IReport;
    import IReportsService = reports.reportsService.IReportsService;


    class ReportsController extends core.controllers.CoreController {
        reports: IReport[];
        getData = () => {
            this.reportsService.getReports((data: IReport[]) => {
                this.reports = data;
            });
        }
        viewReport = (report: IReport) => {
            this.$location.path("/reports/view/" + report.ReportId);
        }
        constructor(
            private reportsService: IReportsService,
            private utilities: IUtilities,
            private $location: ng.ILocationService) {
            super();

            this.getData();

        }
    }

    angular.module("app.reports.reportsController",
        ["app.core.services.utilities", "app.core.services.http", "app.reports.reportsService"])
        .controller("app.reports.reportsController",
            ["app.reports.reportsService", "utilities", "$location", ReportsController]);
} 