
module app.reports.reportsViewController {

    import IUtilities = core.services.IUtilities;
    import IReportRequest = reports.models.IReportRequest;
    import IReportsService = reports.reportsService.IReportsService;
    import IGlobals = interfaces.IGLobals;



    interface IReportRouteParams extends ng.route.IRouteParamsService {
        id: number;
    }

    class ReportsViewController extends core.controllers.CoreController {
        report: IReportRequest;
        reportSource: string;
        reportViewUrl: string;
        getData = (reportId: number) => {
            this.reportsService.getReport(reportId, (data: IReportRequest) => {
                this.report = data;
            });
        }
        runReport = () => {
            this.reportsService.createRequest(this.report, (result: string) => {
                if (result) {
                    this.report.UniqueId = result;
                    this.reportSource = this.globalsService.baseUrl + "ViewsStatic/ReportForm.aspx?r=" + this.report.UniqueId;
                }
            });
        }

        runPdfReport = () => {
            this.reportsService.createRequest(this.report, (result: string) => {
                if (result) {
                    this.report.UniqueId = result;
                    this.reportSource = this.globalsService.baseUrl + "ViewsStatic/ReportHandler.ashx?r=" + this.report.UniqueId;
                }
            });
        }
 
        constructor(
            private reportsService: IReportsService,
            private utilities: IUtilities,
            private $location: ng.ILocationService,
            private $routeParams: IReportRouteParams,
            private globalsService: IGlobals) {

            super();

            this.getData($routeParams.id);
            this.reportViewUrl = undefined;
        }
    }

    angular.module("app.reports.reportsViewController", ["app.core.services.utilities", "app.reports.reportsService", "app.globalsModule"])
        .controller("app.reports.reportsViewController", [
        "app.reports.reportsService", "utilities", "$location", "$routeParams", "globalsService", ReportsViewController]);
} 